saa/routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});


Route::middleware('auth')->group(function () {


    Route::middleware('passwordChanged')->group(function () {
        //Route vers le front
        Route::prefix('front')->namespace('Front')->group(function () {

            //Route notifications
            Route::get('/notifications/unread','NotificationController@getUnreadNotificationOfUser');
            Route::get('/notifications/all', 'NotificationController@getAllNotification');
            Route::get('/notifications/markasread', 'NotificationController@markAsRead');
            Route::get('/notifications/delete', 'NotificationController@deleteNotification');
            Route::delete('/notifications/delete/{id}', 'NotificationController@deleteOneNotification');
            
            //Route offre
            //Route accessible que par les ancien eleve - responsable ou admin du forum ou admin
            Route::middleware('accessFrontCreateOffre')->group(function () {
                route::get('/frontOffre/create', 'OffreController@create')->name('front.offre.create');
                route::post('/frontOffre', 'OffreController@store')->name('front.offre.store');
            });
            //Route accessible que par l'utilisateur de l'offre ou admin
            Route::middleware('accessFrontEditOffre')->group(function () {
                route::patch('/frontOffre/{offre}', 'OffreController@update')->name('front.offre.update');
                route::get('/frontOffre/{offre}/edit', 'OffreController@edit')->name('front.offre.edit');
                route::delete('/frontOffre/{offre}', 'OffreController@destroy')->name('front.offre.destroy');
            });
            //Route accessible par tous
            route::get('/frontOffre', 'OffreController@index')->name('front.offre.index');       
            route::get('/frontOffre/{offre}', 'OffreController@show')->name('front.offre.show');        
            Route::any('/frontOffre/search', 'OffreController@search')->name('front.offre.search');
            Route::get('/frontForum/addFavoriteOffre/{offre}', 'OffreController@addFavorite')->name('front.offre.addFavorite');
            Route::get('/frontForum/removeFavoriteOffre/{offre}', 'OffreController@removeFavorite')->name('front.offre.removeFavorite');


            //Route forum
            //Route accessible que par l'utilisateur du forum ou admin 
            Route::middleware('accessFrontEditForum')->group(function () {
                route::patch('/frontForum/{topic}', 'ForumController@update')->name('front.forum.update');
                route::get('/frontForum/{topic}/edit', 'ForumController@edit')->name('front.forum.edit');
                route::delete('/frontForum/{topic}', 'ForumController@destroy')->name('front.forum.destroy');
            });
            //Route accessible par tous
            route::get('/frontForum', 'ForumController@index')->name('front.forum.index');
            route::get('/frontForum/create', 'ForumController@create')->name('front.forum.create');
            route::post('/frontForum', 'ForumController@store')->name('front.forum.store');
            route::get('/frontForum/{topic}', 'ForumController@show')->name('front.forum.show');
            Route::post('/frontForum/resolu/{topic}', 'ForumController@resoluForum')->name('front.forum.resolu');
            Route::get('/frontForum/addFavoriteTopic/{topic}', 'ForumController@addFavorite')->name('front.forum.addFavorite');
            Route::get('/frontForum/removeFavoriteTopic/{topic}', 'ForumController@removeFavorite')->name('front.forum.removeFavorite');
            Route::get('/mesForums', 'ForumController@indexMesForums')->name('front.mesForum.index');
            Route::any('/mesForums/search', 'ForumController@searchMesForums')->name('front.mesForum.search');


            //Route categorie
            //Route accessible par tous
            route::get('/frontCaregorie', 'CategorieController@index')->name('front.categorie.index');
            route::get('/frontCaregorie/{categorie}', 'CategorieController@show')->name('front.categorie.show');
            Route::any('/frontCaregorie/search/{categorie}', 'CategorieController@search')->name('front.categorie.search');


            //Route reponses forums
            //Route accessible par tous
            Route::post('/reponseTopic/{topic}', 'ReponseController@store')->name('front.reponse.store');
            Route::patch('/reponseTopic/{reponseTopic}', 'ReponseController@update')->name('front.reponse.update');
            Route::delete('/reponseTopic/{reponseTopic}', 'ReponseController@destroy')->name('front.reponse.destroy');


            //Route questionnaire
            Route::middleware('accessFrontQuestionnaire')->group(function () {
                Route::get('/questionnaire', 'QuestionnaireController@index')->name('front.questionnaire.index');
                Route::get('/questionnaire/{questionnaire}', 'QuestionnaireController@show')->name('front.questionnaire.show');
                Route::post('/questionnaire/reponseStore/{questionnaire}', 'QuestionnaireController@reponseStore')->name('front.questionnaire.reponseStore');
                Route::any('/questionnaire/search', 'QuestionnaireController@search')->name('front.questionnaire.search');

                Route::middleware('responsableQuestionnaire')->group(function () {
                    Route::get('/questionnaire/responsableQuestionnaire/create', 'QuestionnaireController@create')->name('front.questionnaire.create');
                    Route::post('/questionnaire/responsableQuestionnaire/store', 'QuestionnaireController@store')->name('front.questionnaire.store');
                    Route::get('/questionnaire/responsableQuestionnaire/{questionnaire}/edit', 'QuestionnaireController@edit')->name('front.questionnaire.edit');
                    route::patch('/questionnaire/responsableQuestionnaire/{questionnaire}', 'QuestionnaireController@update')->name('front.questionnaire.update');
                
                    Route::get('/questionnaire/{questionnaire}/{utilisateur}', 'QuestionnaireController@showUser')->name('front.questionnaire.showUser');
                    
                    //Route pdf
                    Route::get('/dynamic_pdf/pdf/{questionnaire}/{utilisateur}', 'QuestionnaireController@pdf')->name('front.questionnaire.pdf');
                    Route::get('/dynamic_pdf/allpdf/{questionnaire}/', 'QuestionnaireController@allpdf')->name('front.questionnaire.allpdf');
                });    
            });

            //Route profil
            Route::get('/profil', 'ProfilController@profil')->name('front.profil.index');
            Route::get('/favoris', 'ProfilController@favoris')->name('front.profil.favoris');
            Route::put('/profilUpdate', 'ProfilController@updateProfil')->name('front.profil.update');
            Route::put('/profilDesactive', 'ProfilController@desactiveAccount')->name('front.profil.desactive');
            Route::delete('/profilDelete', 'ProfilController@deleteAccount')->name('front.profil.delete');
        });

        //Route vers le back
        Route::middleware('admin')->group(function () {
            Route::prefix('admin')->namespace('Admin')->group(function () {
                Route::name('admin')->get('/', 'AdminController@index');
                Route::resource('/offre', 'OffreController');
                Route::resource('/forum', 'ForumController');
                Route::resource('/questionnaire', 'QuestionnaireController');
                Route::resource('/user', 'UserController');
                Route::resource('/categorie', 'CategorieController');
                Route::resource('/role', 'RoleController');
                Route::patch('/user/active/{user}', 'UserController@active')->name('user.active');
                Route::get('/questionnaire/{questionnaire}/elements-questionnaire/create', 'ElementQuestionnaireController@create')->name('elements-questionnaire.create');
                Route::post('/questionnaire/{questionnaire}/elements-questionnaire', 'ElementQuestionnaireController@store')->name('elements-questionnaire.store');
                route::patch('/questionnaire/{questionnaire}/elements-questionnaire/{element}', 'ElementQuestionnaireController@update')->name('elements-questionnaire.update');
                route::get('/questionnaire/{questionnaire}/elements-questionnaire/{element}/edit', 'ElementQuestionnaireController@edit')->name('elements-questionnaire.edit');
                route::delete('/questionnaire/{questionnaire}/elements-questionnaire/{element}', 'ElementQuestionnaireController@destroy')->name('elements-questionnaire.destroy');
            });
        });
    });
    
    Route::get('/home', 'HomeController@index')->name('home');
    
    Route::post('/changePassword', 'HomeController@changePassword')->name('change-password');
});

    Auth::routes();

saa/app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    protected $primaryKey = 'id_utilisateur';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'nom', 'prenom', 'email','telephone', 'password', 'role_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'remember_token', 'api_token'
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function completeName()
    {
        return $this->prenom." ".$this->nom;
    }

    public function role()
    {
        return $this->belongsTo('App\Models\Role', 'role_id');
    }

    public function offres()
    {
        return $this->hasMany('App\Models\Offre', 'utilisateur_id')->latest();
    }

    public function reponses()
    {
        return $this->hasMany('App\Models\ReponseElement');
    }

    public function topics()
    {
        return $this->hasMany('App\Models\Topic', 'utilisateur_id')->latest();
    }

    public function reponsesTopic()
    {
        return $this->belongsToMany('App\Models\Topic', 'reponse_topics', 'utilisateur_id', 'topic_id')->withPivot('description');
    }

    public function favorisTopic()
    {
        return $this->belongsToMany('App\Models\Topic', 'favoris_topics', 'utilisateur_id', 'topic_id')->withTimestamps();
    }

    public function favorisOffre()
    {
        return $this->belongsToMany('App\Models\Offre', 'favoris_offres', 'utilisateur_id', 'offre_id')->withTimestamps();
    }
}

saa/app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Models\Role;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Response
     */
    public function index()
    {
        return view('admin.user.indexUser', ['users' => User::all()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        return view('admin.user.createUser', ['roles' => Role::all()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return Response
     */
    public function store(Request $request)
    {

        $this->validateData($request, null);

        $user = new User();
        $user->password_changed = 0;
        $this->save($user, $request);
        $this->sendEmail($request->email, $request->password);

        return redirect()->route('user.index')->withToastSuccess('Utilisateur créer avec succès !!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return Response
     */
    public function edit(User $user)
    {
        return view('admin.user.editUser', ['user' => $user, 'roles' => Role::all()]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return Response
     */
    public function update(Request $request, User $user)
    {
        $this->validateData($request, $user);
        
        $user->password_changed = 0;
        $this->save($user, $request);

        return redirect()->route('user.index')->withToastSuccess('Utilisateur modifier avec succès !!');;
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param User $user
     * @return Response
     * @throws Exception
     */
    public function destroy(User $user)
    {
        if($user->delete())
        {
            return redirect()->route('user.index')->withToastSuccess('Utilisateur supprimé avec succès !!');
        }
        return redirect()->route('user.index')->withToastError('Erreur lors de la suppression de l\' utilisateur !!');

    }

    public function active(Request $request, User $user)
    {
        $user->active = !$user->active;
        $user->save();

        return redirect()->back()->withToastSuccess('l\'utilisateur à changer de status');
    }

    private function save(User $user, Request $request)
    {
        $user->nom = $request->nom;
        $user->prenom = $request->prenom;
        $user->email = $request->email;
        $user->telephone = $request->telephone;
        $user->role_id = $request->role_id;
        $user->password = Hash::make($request->password);
        $user->active = true;
        $user->save();
    }

    private function validateData(Request $request, $user)
    {
        if($user != null)
        {
            return \Validator::make($request->all(),[
                'nom' => 'required|string|max:255',
                'prenom' => 'required|string|max:255',
                'telephone' => 'required|string|max:255',
                'email' => 'required|email|'.Rule::unique('users')->ignore($user->id_utilisateur, 'id_utilisateur').'|max:255',
                'role_id' => 'required|integer',
                'password' => 'required|string|min:8|confirmed|max:255',
            ])->validate();
        }
        else
        {
            return \Validator::make($request->all(),[
                'nom' => 'required|string|max:255',
                'prenom' => 'required|string|max:255',
                'telephone' => 'required|string|max:255',
                'email' => 'required|email|max:255|unique:users',
                'role_id' => 'required|integer',
                'password' => 'required|string|min:8|confirmed|max:255',
            ])->validate();
        }
    }

    private function sendEmail($mail, $password){
        $data = array('email' => $mail, 'password' => $password);

        Mail::send('mail', $data, function($message) use ($mail){
            $message->to($mail, 'SuiviASI')->subject('Inscription à la plateforme SuiviASI');
        });
    }
}

saa/resources/views/admin/user/createUser.blade.php
@extends('layouts.admin')
@section('title', 'Création un utilisateur')

@section('content')
    <div class="card card-primary">
        <!-- /.card-header -->
        <!-- form start -->
        <form method="POST" action="{{ route('user.store') }}" enctype="multipart/form-data">
            @csrf

            @method('POST')

            <div class="card-body">
                <div class="row">
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Nom</label>
                            <input type="text" class="form-control @error('nom') is-invalid @enderror" id="nom" name="nom"
                                placeholder="Entrer un nom..." value="{{ old('nom') }}">
                            @error('nom') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('nom') }}</span> @enderror
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Prenom</label>
                            <input type="text" class="form-control @error('prenom') is-invalid @enderror" id="prenom"
                                name="prenom" placeholder="Entrer un prenom..." value="{{ old('prenom') }}">
                            @error('prenom') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('prenom') }}</span> @enderror
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Email</label>
                            <input type="text" class="form-control @error('email') is-invalid @enderror" id="email"
                                name="email" placeholder="Entrer un email..." value="{{ old('email') }}">
                            @error('email') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('email') }}</span> @enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Telephone</label>
                            <input type="text" class="form-control @error('telephone') is-invalid @enderror" id="telephone"
                                name="telephone" placeholder="Entrer un telephone..." value="{{ old('telephone') }}">
                            @error('telephone') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('telephone') }}</span> @enderror
                        </div>
                    </div>

                    <div class="col-md-6" data-select2-id="69">
                        <div class="form-group" data-select2-id="68">
                            <label>Choix du role</label>
                            <select
                                class="form-control select2bs4 select2-hidden-accessible @error('role_id') is-invalid @enderror"
                                style="width: 100%;" data-select2-id="17" tabindex="-1" aria-hidden="true"
                                name="role_id" id="role_id">
                                @foreach ($roles as $role)
                                    <option value="{{ $role->id_role }}">{{ $role->designation }}</option>
                                @endforeach
                            </select>
                            @error('role_id') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('role_id') }}</span> @enderror
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Mot de passe</label>
                            <input type="password" class="form-control @error('password') is-invalid @enderror"
                                id="password" name="password" placeholder="Entrer un mot de passe...">
                            @error('password') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('password') }}</span> @enderror
                        </div>
                    </div>

                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Confirmer le mot de passe</label>
                            <input type="password" class="form-control @error('password') is-invalid @enderror"
                                id="password_confirmation" name="password_confirmation"
                                placeholder="Confirmer le mot de passe...">
                        </div>
                    </div>
                </div>
                @section('script')
                    <script>
                        $(function() {
                            //Initialize Select2 Elements
                            $('.select2bs4').select2({
                                theme: 'bootstrap4'
                            })
                        });

                    </script>
                @endsection

            </div>

        </div>
        <!-- /.card-body -->

        <div class="card-footer">
            <button type="submit" class="btn btn-primary">Créer</button>
        </div>
    </form>
</div>
@endsection

saa/resources/views/admin/user/indexUser.blade.php
@extends('layouts.admin')
@section('title', 'Liste des Utilisateurs')
@section('content')

    <div class="col-md-2" style="margin-bottom:20px;">
        <a href="{{ route('user.create') }}"> <button type="button" class="btn btn-block btn-success">Créer un Utilisateur
                <i class="fas fa-plus-square"></i></button> </a>
    </div>
    <div class="card">

        <div class="card-body">
            <table id="table" class="table table-bordered table-striped table-hover dataTable" role="grid">
                <thead>
                    <tr role="row">
                        <th class="sorting_asc" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Nom</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Prenom</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Email</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Telephone</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Role</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Actif</th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Editer le </th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Créer le </th>
                        <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1"
                            style="text-align: right">Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($users as $user)
                        <tr role="row" class="odd">
                            <td>{{ $user->nom }}</td>
                            <td>{{ $user->prenom }} </td>
                            <td>{{ $user->email }}</td>
                            <td>{{ $user->telephone }}</td>
                            <td>{{ $user->role->designation }}</td>
                            <td>@if($user->active) oui @else non @endif</td>
                            <td>{{ $user->updated_at }}</td>
                            <td>{{ $user->created_at }}</td>
                            <td>
                                <div class="text-center">
                                    <a href="{{ route('user.edit', $user) }}"><button type="button"
                                            class="btn btn-primary "><i class="fas fa-edit"></i></button></a>
                                    <button class="btn btn-danger remove-user" data-name="{{ $user->completeName()}}" data-action="{{ route('user.destroy', $user) }}"><i class="fas fa-trash"></i></button>
                                    @if($user->active)
                                    <button class="btn btn-success active-user" data-name="{{ $user->completeName()}}" data-active="{{$user->active}}" data-action="{{ route('user.active', $user) }}"><i class="fas fa-user-check"></i></button>
                                    @elseif(!$user->active && $user->nom != "supprimé")
                                    <button class="btn btn-danger active-user" data-name="{{ $user->completeName()}}" data-active="{{$user->active}}" data-action="{{ route('user.active', $user) }}"><i class="fas fa-user-times"></i></button>
                                    @endif
                                </div>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
@section('script')
    <script>
        $(function() {
            $("#table").DataTable({
                "responsive": true,
                "autoWidth": false,
                "language": {
                    "url": "//cdn.datatables.net/plug-ins/9dcbecd42ad/i18n/French.json"
                },
            });
        });

        $("body").on("click", ".active-user", function() {

            var current_object = $(this);
            var name = current_object. attr('data-name');
            var active = current_object. attr('data-active');
            var text;
            var textButton;

            if(active == 1)
            {
                text = "Voulez-vous vraiment désactiver l'utilisateur suivant : " + name + " ?"
                textButton = "Désactiver"
            }
            else
            {
                text = "Voulez-vous vraiment activer l'utilisateur suivant : " + name + " ?"
                textButton = "Activer"
            }

            swal.fire({

                title: "Êtes vous sur ?",
                text: text,
                type: 'warning',
                showCancelButton: true,
                cancelButtonColor: '#6c757d',
                confirmButtonColor: '#dc3545',
                confirmButtonText: textButton,
                reverseButtons: true

            }).then((result) => {

                if (result.value) {

                    var action = current_object.attr('data-action');

                    $('body').html("<form class='form-inline remove-form' method='post' action='" + action +
                        "'></form>");
                    $('body').find('.remove-form').append('@csrf');
                    $('body').find('.remove-form').append('@method('PATCH')');
                    $('body').find('.remove-form').submit();
                }

            });

        });

        $("body").on("click", ".remove-user", function() {

        var current_object = $(this);
        var name = current_object. attr('data-name');

        swal.fire({

            title: "Êtes vous sur ?",
            text: "Voulez-vous vraiment supprimer l'utilisateur suivant : " + name + " ?",
            type: 'warning',
            showCancelButton: true,
            cancelButtonColor: '#6c757d',
            confirmButtonColor: '#dc3545',
            confirmButtonText: 'Supprimer !',
            reverseButtons: true

        }).then((result) => {

            if (result.value) {

                var action = current_object.attr('data-action');

                $('body').html("<form class='form-inline remove-form' method='post' action='" + action +
                    "'></form>");
                $('body').find('.remove-form').append('@csrf');
                $('body').find('.remove-form').append('@method('DELETE')');
                $('body').find('.remove-form').submit();
            }

        });

        });

    </script>

@endsection

@endsection